/**
 * Longest Increasing Subsequence (LIS) 
 *
 * Complexity (Time): O(n^2)
 * Complexity (Space): O(n)
 */

int lis(vector<int> v) {
  int n = v.size();

  vector<int> lis(n);
  lis[0] = 1;

  for (int i = 1; i < n; ++i) {
    lis[i] = 1;

    for (int j = 0; j < i; ++j)
      if (v[i] > v[j] and lis[i] < lis[j] + 1)
        lis[i] = lis[j] + 1;
  }

  return *max_element(all(lis));
}
