/** 
 * Ternary Search
 *
 * Complexity (Time): O(log n)
 * Complexity (Space): O(1)
 */

#define EPS 1e-6 

// Unimodal function
double f(double x) {
  return x * x;
}


// Execute ternary search to find maximum or minimum between l and r
double ternary_search(double l, double r) {
  double rt, lt;

  for (int i = 0; i < 500; ++i) {
    if (fabs(r - l) < EPS)
      return (l + r) / 2.0;

    lt = (r - l) / 3.0 + l;
    rt = ((r - l) * 2.0) / 3.0 + l;

    // < | minimum of f
    // > | maximum of f
    if (f(lt) < f(rt))
      l = lt;
    else
      r = rt;
  }

  return (l + r) / 2.0;
}
